package vm

import (
	"context"
	"github.com/jinzhu/copier"
	"github.com/pkg/errors"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/helper/xerr"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/repository/result"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/utils"
	"gitlink.org.cn/JointCloud/pcm-openstack/openstack"
	"k8s.io/apimachinery/pkg/util/json"

	"gitlink.org.cn/JointCloud/pcm-coordinator/internal/svc"
	"gitlink.org.cn/JointCloud/pcm-coordinator/internal/types"

	"github.com/zeromicro/go-zero/core/logx"
)

type CreateNetworkSegmentRangeLogic struct {
	logx.Logger
	ctx    context.Context
	svcCtx *svc.ServiceContext
}

func NewCreateNetworkSegmentRangeLogic(ctx context.Context, svcCtx *svc.ServiceContext) *CreateNetworkSegmentRangeLogic {
	return &CreateNetworkSegmentRangeLogic{
		Logger: logx.WithContext(ctx),
		ctx:    ctx,
		svcCtx: svcCtx,
	}
}

func (l *CreateNetworkSegmentRangeLogic) CreateNetworkSegmentRange(req *types.CreateNetworkSegmentRangeReq) (resp *types.CreateNetworkSegmentRangeResp, err error) {
	// todo: add your logic here and delete this line
	CreateNetworkSegmentRangeReq := &openstack.CreateNetworkSegmentRangeReq{}
	err = copier.CopyWithOption(CreateNetworkSegmentRangeReq, req, copier.Option{Converters: utils.Converters})
	CreateNetworkSegmentRangeResp, err := l.svcCtx.OpenstackRpc.CreateNetworkSegmentRange(l.ctx, CreateNetworkSegmentRangeReq)
	if err != nil {
		return nil, errors.Wrapf(xerr.NewErrMsg("c端创建失败"), "c端创建失败 : %v ,req:%+v", err, req)
	}
	marshal, err := json.Marshal(&CreateNetworkSegmentRangeResp)
	if err != nil {
		return nil, result.NewDefaultError(err.Error())
	}
	json.Unmarshal(marshal, &resp)
	err = copier.CopyWithOption(&resp, &CreateNetworkSegmentRangeResp, copier.Option{Converters: utils.Converters})
	return resp, err
}
